Subject: Re: bug#26150: [PATCH 0/15]: Add pplacer and OCaml dependencies.

From: Ben Woodcroft <[email-masked]>
Date: Wed, 10 May 2017 22:28:02 +0200

Hi Ludo,

On 05/04/17 23:18, Ludovic Courtès wrote:
> Ben Woodcroft <[email-masked]> skribis:
> [...]
>
>> +(define package-with-ocaml4.01
>> +  (package-with-explicit-ocaml (delay (default-ocaml4.01))
>> +                               (delay (default-ocaml4.01-findlib))
>> +                                "ocaml-" "ocaml4.01-"
>> +                                #:variant-property 'ocaml4.01-variant))
> I choked for a few hours on this one, my main problem being that I
> didn’t want us to duplicate the logic from build-system/python.scm.
> This led to commits f37f2b83fa95c1fe2bf01c4b8072cfc23d4c67ec and
> 1618006d0bc9bfdc63f4d199fd980f29ecc78ec4.
>
> Is the “variant” property really needed?  In Python it’s needed because
> the 2.x variants sometimes need a different set of dependencies that
> ‘package-with-python2’ cannot automatically guess.  Conversely,
> ‘package-with-guile-2.0’ has no need for that.
>
> If the variant is not needed, then I recommend using
> ‘package-with-input-rewriting’.
>
> If the variant is needed, then could you use ‘package-mapping’ as in
> 1618006d0bc9bfdc63f4d199fd980f29ecc78ec4?
I ended up pushing this series, ending in 
c033f5d6b5b565c43588d25b7b47d177f0c0933c.

There was one package where a different set of inputs was required 
(ocaml4.01-bisect), so I used 'package-mapping' as suggested. Your 
solution seemed very clean to me, thank you for spending those few hours.

> [...]
>> +      (home-page "http://matsen.fhcrc.org/pplacer")
>> +      (license license:gpl3))))
> Version 3 only?
Afraid so.

>> +;; This package is installed alongside 'pplacer'.  It is a separate package so
>> +;; that it can use the python-build-system for the scripts that are
>> +;; distributed alongside the main OCaml binaries.
>> +(define pplacer-scripts
>> +  (package
>> +    (inherit pplacer)
>> +    (name "pplacer-scripts")
> Maybe add a different synopsis?
OK, good.

> Apologies for taking so long!
Not at all, thank your for help. Very happy to see this package in Guix 
at last.
ben